--[[ 
 -- Copyright (C) 2006-2012 Rivello Multimedia Consulting.                    
 -- code [at] RivelloMultimediaConsulting [dot] com                                                  
 --                                                                      
 -- Permission is hereby granted, free of charge, to any person obtaining
 -- a copy of this software and associated documentation files (the      
 -- "Software"), to deal in the Software without restriction, including  
 -- without limitation the rights to use, copy, modify, merge, publish,  
 -- distribute, sublicense, and#or sell copies of the Software, and to   
 -- permit persons to whom the Software is furnished to do so, subject to
 -- the following conditions:                                            
 --                                                                      
 -- The above copyright notice and this permission notice shall be       
 -- included in all copies or substantial portions of the Software.      
 --                                                                      
 -- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,      
 -- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF   
 -- MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 -- IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR    
 -- OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 -- ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 -- OTHER DEALINGS IN THE SOFTWARE.                                      
--]]  
-- Marks the right margin of code *******************************************************************

--------------------------------------
-- Imports
--------------------------------------
require ("sprite");

--------------------------------------
-- Metadata
--------------------------------------
module (..., package.seeall)

--------------------------------------
-- Class Methods
--------------------------------------
-- PUBLIC STATIC


--------------------------------------
-- Class Properties
--------------------------------------
-- PUBLIC STATIC
 

--------------------------------------
-- Class
--------------------------------------
--[[ 
	This class is designed to...
--]] 
function AbstractGroup()
	
	--------------------------------------
	-- Properties
	--------------------------------------
	
	-- PUBLIC
	
	-- PRIVATE
	--[[ 
		This property is designed to...
	--]]
	local me = display.newGroup();
	
	--------------------------------------
	-- Constructor
	--------------------------------------
	--[[ 
		This is the constructor...
	--]]
	function me:constructor()
		
		--TRACE
		--print ("AbstractGroup:constructor()");
				
		--RETURN
		return me;
	end 
	 
	--[[ 
		This is the initialize.
	--]]
	function me:initialize(aX_num, aY_num, aURL_str, aWidth_num, aHeight_num, aIsSpriteSheet_boolean)
		
		--DRAW
		
		--FLYER IS A SPRITE SHEET, THE OTHERS ARE 1 IMAGE
		if aIsSpriteSheet_boolean == true then
				
			-- A sprite sheet with a cat
			local mySpriteSheet = sprite.newSpriteSheet( aURL_str, aWidth_num, aHeight_num );
			 
			local mySpriteSet = sprite.newSpriteSet(mySpriteSheet, 1, 2);
			sprite.add( mySpriteSet, "doAnimate", 1, 2, 300, 1 ); --  spriteSet, sequenceName, startFrame, frameCount, time, [loopParam] )
			 
			me.image = sprite.newSprite( mySpriteSet );
			me.image.xScale = 1;
			me.image.yScale = 1;
			 me.image:setReferencePoint( display.CenterReferencePoint );
			me.image:prepare("doAnimate");
			me.image:play();
			me:insert (me.image);

		else
			--[[ 
			
				me.image:setReferencePoint( ... );
			
				display.CenterReferencePoint
			    display.TopLeftReferencePoint
			    display.TopCenterReferencePoint
			    display.TopRightReferencePoint
			    display.CenterRightReferencePoint
			    display.BottomRightReferencePoint
			    display.BottomCenterReferencePoint
			    display.BottomLeftReferencePoint
			    display.CenterLeftReferencePoint
			--]]
			
			me.image = display.newImageRect(aURL_str, aWidth_num, aHeight_num); 
			me.image:setReferencePoint( display.CenterReferencePoint );
			me:insert (me.image);

		end
		
		--PROPERTIES
		me.image.x = 0;
		me.image.y = 0;
		me.x = aX_num;
		me.y = aY_num;
		
	end

	--------------------------------------
	-- Methods
	-------------------------------------- 
	
	-- PUBLIC
	
	-- PRIVATE

	--------------------------------------
	-- Events
	-------------------------------------- 
	-- PUBLIC
	

	-- RETURN INSTANCE VIA CONSTRUCTOR
	return me:constructor();
end
