--[[ 
 -- Copyright (C) 2006-2012 Rivello Multimedia Consulting.                    
 -- code [at] RivelloMultimediaConsulting [dot] com                                                  
 --                                                                      
 -- Permission is hereby granted, free of charge, to any person obtaining
 -- a copy of this software and associated documentation files (the      
 -- "Software"), to deal in the Software without restriction, including  
 -- without limitation the rights to use, copy, modify, merge, publish,  
 -- distribute, sublicense, and#or sell copies of the Software, and to   
 -- permit persons to whom the Software is furnished to do so, subject to
 -- the following conditions:                                            
 --                                                                      
 -- The above copyright notice and this permission notice shall be       
 -- included in all copies or substantial portions of the Software.      
 --                                                                      
 -- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,      
 -- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF   
 -- MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 -- IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR    
 -- OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 -- ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 -- OTHER DEALINGS IN THE SOFTWARE.                                      
--]]  
-- Marks the right margin of code *******************************************************************

--------------------------------------
-- Imports
--------------------------------------
local AssetManager 			= require ("com.rmc.projects.flyergame.managers.AssetManager");


--------------------------------------
-- Metadata
--------------------------------------
module (..., package.seeall)

--------------------------------------
-- Class Methods
--------------------------------------
-- PUBLIC STATIC

--------------------------------------
-- Class Properties
--------------------------------------
-- PUBLIC STATIC


--------------------------------------
-- Class
--------------------------------------
--[[ 
	This class is designed to...
--]] 
function SoundManager()
	
	--------------------------------------
	-- Properties
	--------------------------------------
	
	-- PRIVATE
	--[[ 
		Self-Reference
	--]]
	local me = {};
	
	--[[ 
		Self-Reference
	--]]
	local assetManager = AssetManager.AssetManager();
	
	-- PUBLIC
	
	--------------------------------------
	-- Constructor
	--------------------------------------
	--[[ 
		This is the constructor...
	--]]
	function me:constructor()
		
		--TRACE
				
		--RETURN
		return me;
	end 
	 
	--[[ 
		One Time Setup
	--]]
	function me:initialize()
	
		--TRACE
		
		--SETUP
			
	end 
	
	--------------------------------------
	-- Methods
	-------------------------------------- 
	
	-- PUBLIC
	
	--[[ 
		PLAY SOUND: Based on URL
	--]]
	function me:playSound(aURL_str)
	
		--TRACE
		
		--SETUP
		local explosionSound = audio.loadSound(aURL_str)
		audio.play(explosionSound)  
			
	end  
	
	
	--[[ 
		PLAY SOUND: When the Flyer Moves
	--]]
	function me:playMoveFlyerSound()
		--SETUP
		me:playSound (assetManager.SOUND_MOVE_FLYER_SOUND)
	end  
	
	
	--[[ 
		PLAY SOUND: When the Flyer Loses
	--]]
	function me:playLoseGameSound()
		--SETUP
		me:playSound (assetManager.SOUND_LOSE_GAME_SOUND)
	end  
	
	
	--[[ 
		PLAY SOUND: When the Flyer Wins
	--]]
	function me:playWinGameSound()
		--SETUP
		me:playSound (assetManager.SOUND_MOVE_FLYER_SOUND)
	end  
	 
	
	-- PRIVATE

	--------------------------------------
	-- Events
	-------------------------------------- 
	-- PUBLIC
	
	-- RETURN INSTANCE VIA CONSTRUCTOR
	me:initialize();
	return me:constructor();
end
