--[[ 
 -- Copyright (C) 2006-2012 Rivello Multimedia Consulting.                    
 -- code [at] RivelloMultimediaConsulting [dot] com                                                  
 --                                                                      
 -- Permission is hereby granted, free of charge, to any person obtaining
 -- a copy of this software and associated documentation files (the      
 -- "Software"), to deal in the Software without restriction, including  
 -- without limitation the rights to use, copy, modify, merge, publish,  
 -- distribute, sublicense, and#or sell copies of the Software, and to   
 -- permit persons to whom the Software is furnished to do so, subject to
 -- the following conditions:                                            
 --                                                                      
 -- The above copyright notice and this permission notice shall be       
 -- included in all copies or substantial portions of the Software.      
 --                                                                      
 -- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,      
 -- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF   
 -- MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 -- IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR    
 -- OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 -- ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 -- OTHER DEALINGS IN THE SOFTWARE.                                      
--]]  
-- Marks the right margin of code *******************************************************************

--------------------------------------
-- Imports
--------------------------------------
local AbstractGroup 	= require ("com.rmc.components.AbstractGroup");

--------------------------------------
-- Metadata
--------------------------------------
module (..., package.seeall)

--------------------------------------
-- Class Methods
--------------------------------------
-- PUBLIC STATIC


--------------------------------------
-- Class Properties
--------------------------------------
-- PUBLIC STATIC
 

--------------------------------------
-- Class
--------------------------------------
--[[ 
	This class is designed to...
--]] 
function Enemy(aTable, aX_num, aY_num, aURL_str, aWidth_num, aHeight_num, aXSpeed_num)
	
	--------------------------------------
	-- Properties
	--------------------------------------
	print ("in the enemy---------------")
	-- PUBLIC
	
	-- PRIVATE
	--[[ 
		Self reference.
	--]]
	local me = AbstractGroup:AbstractGroup();
	
	--------------------------------------
	-- Constructor
	--------------------------------------
	--[[ 
		Only The Parent-Most class has a constructor
	--]]
	 
	--[[ 
		This is the initialize.
	--]] 
	me.superInitialize 	= me.initialize;	--allow method override
	function me:initialize(aX_num, aY_num, aURL_str, aWidth_num, aHeight_num, aXSpeed_num)
		 
		--TRACE
		print (">>>>>>Enemy:initialize()");
		
		local xSpeed_num = aXSpeed_num;
		
		--SUPER
		me:superSuperInitialize(aX_num, aY_num, aURL_str, aWidth_num, aHeight_num)

		
	end

	--------------------------------------
	-- Methods
	-------------------------------------- 
	
	-- PUBLIC
	
	-- PRIVATE

	--------------------------------------
	-- Events
	-------------------------------------- 
	-- PUBLIC
	--[[ 
		-- The Game Loop (Movement, Etc...)
	--]]
	function me:enterFrame( event )
		
		--MOVE POSITION
		if xSpeed_num == nil then
		   xSpeed_num = -5;
		end
		
		--me.x = me.x + xSpeed_num;

		--CORRECT POSITION IF OFFSCREEN
		if me.x - me.width > display.contentWidth then
			me.x = -me.width;
		elseif me.x + me.width < 0 then
			me.x = display.contentWidth;
		end
	    
	end

	-- RETURN INSTANCE VIA CONSTRUCTOR
	me:initialize(aX_num, aY_num, aURL_str, aWidth_num, aHeight_num, aXSpeed_num );
	return me:constructor();
end
