--[[ 
 -- Copyright (C) 2006-2012 Rivello Multimedia Consulting.                    
 -- code [at] RivelloMultimediaConsulting [dot] com                                                  
 --                                                                      
 -- Permission is hereby granted, free of charge, to any person obtaining
 -- a copy of this software and associated documentation files (the      
 -- "Software"), to deal in the Software without restriction, including  
 -- without limitation the rights to use, copy, modify, merge, publish,  
 -- distribute, sublicense, and#or sell copies of the Software, and to   
 -- permit persons to whom the Software is furnished to do so, subject to
 -- the following conditions:                                            
 --                                                                      
 -- The above copyright notice and this permission notice shall be       
 -- included in all copies or substantial portions of the Software.      
 --                                                                      
 -- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,      
 -- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF   
 -- MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 -- IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR    
 -- OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 -- ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 -- OTHER DEALINGS IN THE SOFTWARE.                                      
--]]  
-- Marks the right margin of code *******************************************************************

--------------------------------------
-- Imports
--------------------------------------
local AbstractScene 	= require ("com.rmc.scenes.AbstractScene");
local BackgroundImage 	= require ("com.rmc.projects.flyergame.groups.BackgroundImage");
local Storyboard 		= require ("storyboard");


--------------------------------------
-- Metadata
--------------------------------------
module (..., package.seeall)

--------------------------------------
-- Class Methods
--------------------------------------
-- PUBLIC STATIC


--------------------------------------
-- Class Properties
--------------------------------------
-- PUBLIC STATIC


--------------------------------------
-- Class
--------------------------------------
--[[ 
	This class is designed to...
--]] 
function MainMenuScene()
	
	--------------------------------------
	-- Properties
	--------------------------------------
	
	-- PUBLIC
	
	-- PRIVATE
	--[[ 
		This property is designed to...
	--]]
	local me = AbstractScene:AbstractScene();
	
	
	--------------------------------------
	-- Constructor
	--------------------------------------
	--[[ 
		Only The Parent-Most class has a constructor
	--]]
	 
	--[[ 
		This is the initialize.
	--]]
	me.superInitialize = me.initialize;		--allow method override
	function me:initialize()
		
		--TRACE
		print ("MainMenuScene:initialize()");
		
		--SUPER
		me:superInitialize();

		
	end
	
	--------------------------------------
	-- Methods
	-------------------------------------- 
	
	-- PUBLIC
	--[[ 
		-- "createScene" event is dispatched if scene's view does not exist
	--]]
	me.superCreateScene = me.createScene;	--allow method override
	function me:createScene( event )
	   
		--TRACE
		print ("MainMenuScene:createScene()"); 
		
		--SUPER
		me:superCreateScene(); 
			   	   
		--CREATE LAYOUT
	  	local group = self.view;
	  	
		--CREATE IMAGE
		local backgroundImage = BackgroundImage:BackgroundImage("./media/images/background.png");
		
		--ADD TO LAYOUT
		group:insert( backgroundImage )
			
	end
	
	--[[ 
		-- "enterScene" event is dispatched whenever scene transition has finished
	--]]
	me.superEnterScene = me.enterScene;		--allow method override
	function me:enterScene( event )
			
		--TRACE
		print ("MainMenuScene:enterScene()");
				
		--SUPER
		me:superEnterScene();
		
		--EVENTS
		Runtime:addEventListener( "tap", me );
		
	end
	
	--[[ 
		-- "exitScene" event is dispatched whenever before next scene's transition begins.
	--]]
	me.superExitScene = me.exitScene;	--allow method override
	function me:exitScene( event )
			
		--TRACE
		print ("MainMenuScene:exitScene()");
				
		--SUPER
		me:superExitScene();
		
		--EVENTS
		Runtime:removeEventListener( "tap", me );
		
	end
	
	
	-- PRIVATE
	

	--------------------------------------
	-- Events
	-------------------------------------- 
	
	-- PUBLIC
		
	--[[ 
		-- When touched by finger
	--]]
	function me:tap( event )
	    Storyboard.gotoScene( "com.rmc.projects.flyergame.scenes.GameScene", "crossFade", 500 )
	    
	end

	
	-- RETURN INSTANCE VIA CONSTRUCTOR
	me:initialize();
	return me;
end




--------------------------------------
-- Instantiate
--------------------------------------
local mainMenuScene = MainMenuScene();
return mainMenuScene;