--[[ 
 -- Copyright (C) 2006-2012 Rivello Multimedia Consulting.                    
 -- code [at] RivelloMultimediaConsulting [dot] com                                                  
 --                                                                      
 -- Permission is hereby granted, free of charge, to any person obtaining
 -- a copy of this software and associated documentation files (the      
 -- "Software"), to deal in the Software without restriction, including  
 -- without limitation the rights to use, copy, modify, merge, publish,  
 -- distribute, sublicense, and#or sell copies of the Software, and to   
 -- permit persons to whom the Software is furnished to do so, subject to
 -- the following conditions:                                            
 --                                                                      
 -- The above copyright notice and this permission notice shall be       
 -- included in all copies or substantial portions of the Software.      
 --                                                                      
 -- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,      
 -- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF   
 -- MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 -- IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR    
 -- OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 -- ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 -- OTHER DEALINGS IN THE SOFTWARE.                                      
--]]  
-- Marks the right margin of code *******************************************************************

--------------------------------------
-- Imports
--------------------------------------


--------------------------------------
-- Metadata
--------------------------------------
module (..., package.seeall)

--------------------------------------
-- Class Methods
--------------------------------------
-- PUBLIC STATIC
--[[ 
	This method is designed to...
--]]
function TemplateClass:SampleStaticMethod()
	return "SampleStaticMethod";
end

--------------------------------------
-- Class Properties
--------------------------------------
-- PUBLIC STATIC
--[[ 
	This property is designed to...
--]]
TemplateClass.SampleStaticProperty = "SamplePublicProperty";


--------------------------------------
-- Class
--------------------------------------
--[[ 
	This class is designed to...
--]] 
function TemplateClass()
	
	--------------------------------------
	-- Properties
	--------------------------------------
	
	-- PUBLIC
	
	-- PRIVATE
	--[[ 
		This property is designed to...
	--]]
	local me = {};
	
	--------------------------------------
	-- Constructor
	--------------------------------------
	--[[ 
		This is the constructor...
	--]]
	function me:constructor()
		return me;
	end

	
	--------------------------------------
	-- Methods
	-------------------------------------- 
	
	-- PUBLIC
	--[[ 
		This method is designed to...
	--]]
	function me:samplePublicMethod()

		--Test Private -- Works!
		--local _samplePrivateMethod_str = _samplePrivateMethod();
		--print ("***_samplePrivateMethod_str   : " .. _samplePrivateMethod_str);

		return "samplePublicMethod";
	end

	
	-- PRIVATE
	--[[ 
		This method is designed to...
	--]]
	function _samplePrivateMethod()
		return "_samplePrivateMethod";
	end


	--------------------------------------
	-- Events
	-------------------------------------- 
	
	-- PRIVATE
	--[[ 
		This event handler is designed to...
	--]]
	function _onSampleEvent()
		return "_onSampleEvent";
	end
	
	
	-- RETURN INSTANCE VIA CONSTRUCTOR
	return me:constructor();
end


--------------------------------------
-- Instantiate
--------------------------------------
local TemplateClass = TemplateClass();
return TemplateClass;
 