--[[ 
 -- Copyright (C) 2006-2012 Rivello Multimedia Consulting.                    
 -- code [at] RivelloMultimediaConsulting [dot] com                                                  
 --                                                                      
 -- Permission is hereby granted, free of charge, to any person obtaining
 -- a copy of this software and associated documentation files (the      
 -- "Software"), to deal in the Software without restriction, including  
 -- without limitation the rights to use, copy, modify, merge, publish,  
 -- distribute, sublicense, and#or sell copies of the Software, and to   
 -- permit persons to whom the Software is furnished to do so, subject to
 -- the following conditions:                                            
 --                                                                      
 -- The above copyright notice and this permission notice shall be       
 -- included in all copies or substantial portions of the Software.      
 --                                                                      
 -- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,      
 -- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF   
 -- MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 -- IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR    
 -- OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 -- ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 -- OTHER DEALINGS IN THE SOFTWARE.                                      
--]]  
-- Marks the right margin of code *******************************************************************

--------------------------------------
-- Imports
--------------------------------------
local storyboard 	= require( "storyboard" )

--------------------------------------
-- Metadata
--------------------------------------
module (..., package.seeall)

--------------------------------------
-- Class Methods
--------------------------------------
-- PUBLIC STATIC


--------------------------------------
-- Class Properties
--------------------------------------
-- PUBLIC STATIC
 

--------------------------------------
-- Class
--------------------------------------
--[[ 
	This class is designed to...
--]] 
function AbstractScene()
	
	--------------------------------------
	-- Properties
	--------------------------------------
	
	-- PUBLIC
	
	-- PRIVATE
	--[[ 
		This property is designed to...
	--]]
	local me = storyboard.newScene();
	
	--------------------------------------
	-- Constructor
	--------------------------------------
	--[[ 
		This is the constructor...
	--]]
	function me:constructor()
		
		--TRACE
		print ("AbstractScene:constructor()");
				
		--RETURN
		return me;
	end
	
	--[[ 
		This is the initialize.
	--]]
	function me:initialize()
		
		--TRACE
		print ("AbstractScene:initialize()");
				
		--EVENTS
		me:addEventListener( "createScene", 	me )
		me:addEventListener( "enterScene", 		me )
		me:addEventListener( "exitScene", 		me )
		me:addEventListener( "destroyScene", 	me )
		
	end

	--------------------------------------
	-- Methods
	-------------------------------------- 
	
	-- PUBLIC
	
	-- PRIVATE

	--------------------------------------
	-- Events
	-------------------------------------- 
	-- PUBLIC
	--[[ 
		-- "createScene" event is dispatched if scene's view does not exist
	--]]
	function me:createScene( event )
			
		--TRACE
		print ("AbstractScene:createScene()");
	end
		
	
	--[[ 
		-- "enterScene" event is dispatched whenever scene transition has finished
	--]]
	function me:enterScene( event )
			
		--TRACE
		print ("AbstractScene:enterScene()");
	end
	
	--[[ 
		-- "exitScene" event is dispatched whenever before next scene's transition begins.
	--]]
	function me:exitScene( event )
			
		--TRACE
		print ("AbstractScene:exitScene()");
	end
	
	--[[ 
		-- "destroyScene" event is dispatched before view is unloaded, which can be
		-- automatically unloaded in low memory situations, or explicitly via a call to
		-- storyboard.purgeScene() or storyboard.removeScene().
	--]]
	function me:destroyScene( event )
			
		--TRACE
		print ("AbstractScene:destroyScene()");
		
		--EVENTS
		me:removeEventListener( "createScene", 		me )
		me:removeEventListener( "enterScene", 		me )
		me:removeEventListener( "exitScene", 		me )
		me:removeEventListener( "destroyScene", 	me )
		
	end

	-- RETURN INSTANCE VIA CONSTRUCTOR
	return me:constructor();
end




--------------------------------------
-- Instantiate
--------------------------------------
--DO NOT INSTANTIATE THIS CLASS DIRECTLY. INSTANTIATE SUBCLASSES